#ifndef BUSSIM_STOP_H_INCLUDED
#define BUSSIM_STOP_H_INCLUDED

#include "string"

struct BUSSIM_ASSIGNED_POINT {
    int PT_ID;      // ID of referenced BUSSIM_POINT-object
    struct BUSSIM_ASSIGNED_POINT *next;
    class BUSSIM_STOP *ref2stop;
};

struct BUSSIM_ASSIGNED_ARC {
    int ARC_ID;      // ID of referred BUSSIM_ARC-object
    struct BUSSIM_ASSIGNED_ARC *next;
    class BUSSIM_STOP *ref2stop;
};

class BUSSIM_STOP {
public:
    long ID;        // unique identifier of a stop object
    std::string STOP_NAME;
    std::string STOP_SHORT_NAME;

    int ASSIGNED_POINTS;
    struct BUSSIM_ASSIGNED_POINT *first_point;
    struct BUSSIM_ASSIGNED_POINT *last_point;

    int ASSIGNED_ARCS;
    struct BUSSIM_ASSIGNED_ARC *first_arc;
    struct BUSSIM_ASSIGNED_ARC *last_arc;

    int ASSIGNED_INBOUND_ARCS;
    struct BUSSIM_ASSIGNED_ARC *first_inbound_arc;
    struct BUSSIM_ASSIGNED_ARC *last_inbound_arc;

    int ASSIGNED_OUTBOUND_ARCS;
    struct BUSSIM_ASSIGNED_ARC *first_outbound_arc;
    struct BUSSIM_ASSIGNED_ARC *last_outbound_arc;

    double RED;
    double GREEN;
    double BLUE;

    BUSSIM_STOP();  // the constructor
    ~BUSSIM_STOP(); // the destructor
    void specify(long _ID, std::string _STOP_NAME, std::string _STOP_SHORT_NAME);
    void append_point(int _ID);
    void append_arc(int _ID);
    void append_inbound_arc(int _ID);
    void append_outbound_arc(int _ID);
};

#endif // BUSSIM_STOP_H_INCLUDED
