#include "bussim_global.h"
//#include "bussim_toi.h"

#include <iostream>
#include <stdio.h>
#include <cstring>
#include <cmath>

//#include <GL/gl.h>
//#include <freeglut/freeglut.h>

BUSSIM_TOI::BUSSIM_TOI()
{
    strcpy(this->title,"not specified");
    this->type = 0;
    this->width = 1.0;
    this->PT = nullptr;
}


BUSSIM_TOI::~BUSSIM_TOI()
{

}

void BUSSIM_TOI::add_coordinate_longlat(double _long, double _lat)
{
    // goto last saved coordinate
    if( this->PT == nullptr )
    {
        // no coordinate saved so far
        this->PT = new struct BUSSIM_TOI_POINT;
        this->PT->next = nullptr;
        this->PT->longitude = _long;
        this->PT->latitude = _lat;
        this->PT->world_x = 0;
        this->PT->world_y = 0;
        this->PT->screen_x = -2;
        this->PT->screen_y = -2;
    }
    else
    {
        // move forward to the last stored node
        struct BUSSIM_TOI_POINT *Tmp;
        Tmp = this->PT;
        while( Tmp->next != nullptr )
        {
            Tmp = Tmp->next;
        }
        Tmp->next= new struct BUSSIM_TOI_POINT;
        Tmp->next->next = nullptr;
        Tmp->next->longitude = _long;
        Tmp->next->latitude = _lat;
        Tmp->next->world_x = 0;
        Tmp->next->world_y = 0;
        Tmp->next->screen_x = -2;
        Tmp->next->screen_y = -2;
    }
}

void BUSSIM_TOI::calculate_screen_coordinates(class BUSSIM_NETWORK *_NET, double _xmin, double _xmax, double _ymin, double _ymax)
{
    struct BUSSIM_TOI_POINT *Tmp;
    Tmp = this->PT;
    while( Tmp != nullptr )
    {
        if( (_ymax - _ymin) > (_xmax - _xmin) )
        {
            _NET->y_factor = 1;
            _NET->x_factor = (_xmax - _xmin) / (_ymax - _ymin);
        }
        else
        {
            _NET->x_factor = 1;
            _NET->y_factor = (_ymax - _ymin) / (_xmax - _xmin);
        }

        Tmp->screen_x = -1 + (Tmp->world_x-_xmin)/(_xmax-_xmin)*2*_NET->x_factor;
        Tmp->screen_y = -1 + (Tmp->world_y-_ymin)/(_ymax-_ymin)*2*_NET->y_factor;

        Tmp = Tmp->next;
    }
}

void BUSSIM_TOI::draw(void)
{
    if( this->type == BUSSIM_TOI_WATER )
    {

    glColor4f(0.0f,0.0f,1.0f,0.0f);
    glLineWidth((GLfloat)(8.5*this->width));
    glEnable( GL_LINE_SMOOTH );
    glBegin(GL_LINES);

    struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            glVertex2f(Ptr->screen_x,Ptr->screen_y);
            glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    glEnd();

    glColor4f(0.2f,0.5f,1.0f,0.0f);
    glLineWidth((GLfloat)(5.5*this->width) );
    glBegin(GL_LINES);

    //struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            glVertex2f(Ptr->screen_x,Ptr->screen_y);
            glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    glEnd();

    glLineWidth((GLfloat)1.0);
    glDisable( GL_LINE_SMOOTH );
    }

    if( this->type == BUSSIM_TOI_HIGHWAY )
    {

    glColor4f(0.8f,0.6f,0.5f,0.0f);
    glLineWidth((GLfloat)4.5);
    glEnable( GL_LINE_SMOOTH );
    glBegin(GL_LINES);

    struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            glVertex2f(Ptr->screen_x,Ptr->screen_y);
            glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    glEnd();

    glColor4f(0.8f,0.8f,0.8f,0.0f);
    glLineWidth((GLfloat)2.5);
    glBegin(GL_LINES);

    //struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            glVertex2f(Ptr->screen_x,Ptr->screen_y);
            glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    glEnd();

    glLineWidth((GLfloat)1.0);
    glDisable( GL_LINE_SMOOTH );
    }

    if( this->type == BUSSIM_TOI_FOREST )
    {

    glColor4f(0.0f,0.3f,0.0f,0.0f);
    glLineWidth((GLfloat)4.5);
    glEnable( GL_LINE_SMOOTH );
    glBegin(GL_POLYGON);

    struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            glVertex2f(Ptr->screen_x,Ptr->screen_y);
            glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    glEnd();

    glColor4f(0.0f,0.3f,0.0f,0.0f);
    glLineWidth((GLfloat)2.5);
    glBegin(GL_POLYGON);

    //struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            glVertex2f(Ptr->screen_x,Ptr->screen_y);
            glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    glEnd();

    glLineWidth((GLfloat)1.0);
    glDisable( GL_LINE_SMOOTH );
    }

    if( this->type == BUSSIM_TOI_LAKE )
    {

    glColor4f(0.0f,0.0f,0.8f,0.0f);
    glLineWidth((GLfloat)4.5);
    glEnable( GL_LINE_SMOOTH );
    glBegin(GL_POLYGON);

    struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            glVertex2f(Ptr->screen_x,Ptr->screen_y);
            glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    glEnd();

    glColor4f(0.0f,0.0f,1.0f,0.0f);
    glLineWidth((GLfloat)2.5);
    glBegin(GL_POLYGON);

    //struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            glVertex2f(Ptr->screen_x,Ptr->screen_y);
            glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    glEnd();

    glLineWidth((GLfloat)1.0);
    glDisable( GL_LINE_SMOOTH );
    }

    if( this->type == 222 )
    {

    glColor4f(1.0f,1.0f,1.0f,0.0f);
    glLineWidth((GLfloat)(4.5*this->width));
    glEnable( GL_LINE_SMOOTH );
    glBegin(GL_LINES);

    struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            glVertex2f(Ptr->screen_x,Ptr->screen_y);
            glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    glEnd();



    //struct BUSSIM_TOI_POINT *Ptr;
    Ptr = this->PT;
    double diff_x;
    double diff_y;
    while( Ptr != nullptr )
    {
        if( Ptr->next != nullptr )
        {
            diff_x = ( Ptr->next->screen_x - Ptr->screen_x ) / 10.0;
            diff_y = ( Ptr->next->screen_y - Ptr->screen_y ) / 10.0;
            for( int p = 0 ; p < 9 ; p++ )
            {
                if( p % 2 == 0 )
                {
                    glColor4f(1.0f,1.0f,1.0f,0.0f);
                    glLineWidth((GLfloat)(3.2*this->width) );
                    glBegin(GL_LINES);
                }
                else
                {
                    glColor4f(0.1f,0.1f,0.1f,0.0f);
                    glLineWidth((GLfloat)(3.2*this->width) );
                    glBegin(GL_LINES);
                }
                glVertex2f(Ptr->screen_x+p*diff_x,Ptr->screen_y+p*diff_y);
                glVertex2f(Ptr->screen_x+(p+1)*diff_x,Ptr->screen_y+(p+1)*diff_y);
                glEnd();
            }
            //glVertex2f(Ptr->screen_x,Ptr->screen_y);
            //glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
        }
        Ptr = Ptr->next;
    }

    //glEnd();

    glLineWidth((GLfloat)1.0);
    glDisable( GL_LINE_SMOOTH );
    }

    if( this->type == BUSSIM_TOI_RAILTRACK )
    {
        // print the outer line
        glColor4f(1.0f,1.0f,1.0f,0.0f);
        glLineWidth((GLfloat)(4.5*this->width));
        glEnable( GL_LINE_SMOOTH );
        glBegin(GL_LINES);

        struct BUSSIM_TOI_POINT *Ptr;
        Ptr = this->PT;
        while( Ptr != nullptr )
        {
            if( Ptr->next != nullptr )
            {
                glVertex2f(Ptr->screen_x,Ptr->screen_y);
                glVertex2f(Ptr->next->screen_x,Ptr->next->screen_y);
            }
            Ptr = Ptr->next;
        }

        glEnd();

        // now overlay with alternating Black/white stripe

        double SEG_LEN = 0.025;
        double VEC_LEN = 0.0;
        double REMAIN_VEC_LEN =0.0;
        double LEN_FROM_LAST = 0.0;
        double start_x, start_y;

        int SEG_CNTR = 1;          // even = BLACK, uneven = WHITE
        Ptr = this->PT;
        double diff_x, diff_y;
        while( Ptr != nullptr )
        {
            if( Ptr->next != nullptr )
            {
                // determine the direction vector
                diff_x = ( Ptr->next->screen_x - Ptr->screen_x );
                diff_y = ( Ptr->next->screen_y - Ptr->screen_y );

                start_x = Ptr->screen_x;
                start_y = Ptr->screen_y;

                // and its length
                VEC_LEN = sqrt(pow(Ptr->next->screen_x - Ptr->screen_x,2.0) + pow(Ptr->next->screen_y - Ptr->screen_y,2));

                // first check if we have to finish a segment from previous arc
                if( LEN_FROM_LAST > 0 )
                {
                    // we have to continue with color from end of previous arc
                    if( SEG_CNTR % 2 == 0 )
                    {
                        glColor4f(1.0f,1.0f,1.0f,0.0f);
                        glLineWidth((GLfloat)(3.2*this->width) );
                    }
                    else
                    {
                        glColor4f(0.2f,0.2f,0.2f,0.0f);
                        glLineWidth((GLfloat)(3.2*this->width) );
                    }

                    // now we check if the open segment exceeded VEC_LEN
                    if( LEN_FROM_LAST > VEC_LEN )
                    {
                        // we have only one segment printed in same color as incomplete segment from previous arc
                        glBegin(GL_LINES);
                            glVertex2f(Ptr->screen_x,Ptr->screen_y);
                            glVertex2f(Ptr->screen_x+diff_x,Ptr->screen_y+diff_y);
                        glEnd();

                        LEN_FROM_LAST = LEN_FROM_LAST - sqrt(pow(diff_x,2.0)+pow(diff_y,2.0));
                    }
                    else
                    {
                        // we have more than the remaining segment from previous arc
                        // start to complete the segment from previous arc
                        diff_x = LEN_FROM_LAST / VEC_LEN * ( Ptr->next->screen_x - Ptr->screen_x );
                        diff_y = LEN_FROM_LAST / VEC_LEN * ( Ptr->next->screen_y - Ptr->screen_y );
                        glBegin(GL_LINES);
                            glVertex2f(Ptr->screen_x,Ptr->screen_y);
                            glVertex2f(Ptr->screen_x+diff_x,Ptr->screen_y+diff_y);
                        glEnd();
                        SEG_CNTR++;

                        // update the vector start
                        start_x = start_x + diff_x;
                        start_y = start_y + diff_y;

                        // determine the remaining vector length to split in segments
                        REMAIN_VEC_LEN = VEC_LEN - LEN_FROM_LAST;

                        LEN_FROM_LAST = 0;


                        // now print the segments
                        while( REMAIN_VEC_LEN >= SEG_LEN )
                        {
                            // set the color
                            if( SEG_CNTR % 2 == 0 )
                            {
                                glColor4f(1.0f,1.0f,1.0f,0.0f);
                                glLineWidth((GLfloat)(3.2*this->width) );
                            }
                            else
                            {
                                glColor4f(0.2f,0.2f,0.2f,0.0f);
                                glLineWidth((GLfloat)(3.2*this->width) );
                            }

                            // specify the vector offset
                            diff_x = SEG_LEN / VEC_LEN * ( Ptr->next->screen_x - Ptr->screen_x );
                            diff_y = SEG_LEN / VEC_LEN * ( Ptr->next->screen_y - Ptr->screen_y );

                            // draw the segment
                            glBegin(GL_LINES);
                                glVertex2f(start_x,start_y);
                                glVertex2f(start_x+diff_x,start_y+diff_y);
                            glEnd();
                            SEG_CNTR++;

                            // update the start location of the next segment
                            start_x = start_x + diff_x;
                            start_y = start_y + diff_y;

                            // update the remaining vector length
                            REMAIN_VEC_LEN = REMAIN_VEC_LEN - SEG_LEN;

                        }

                        // check if we have to open an incomplete segment
                        if( REMAIN_VEC_LEN > 0 )
                        {
                            // start a segment that is continued on the next arc
                            // set the color
                            if( SEG_CNTR % 2 == 0 )
                            {
                                glColor4f(1.0f,1.0f,1.0f,0.0f);
                                glLineWidth((GLfloat)(3.2*this->width) );
                            }
                            else
                            {
                                glColor4f(0.2f,0.2f,0.2f,0.0f);
                                glLineWidth((GLfloat)(3.2*this->width) );
                            }

                            // specify the vector offset
                            diff_x = REMAIN_VEC_LEN / VEC_LEN * ( Ptr->next->screen_x - Ptr->screen_x );
                            diff_y = REMAIN_VEC_LEN / VEC_LEN * ( Ptr->next->screen_y - Ptr->screen_y );

                            // draw the segment
                            glBegin(GL_LINES);
                                glVertex2f(start_x,start_y);
                                glVertex2f(start_x+diff_x,start_y+diff_y);
                            glEnd();
                        }

                        LEN_FROM_LAST = SEG_LEN - REMAIN_VEC_LEN;
                        REMAIN_VEC_LEN = 0;
                    }
                }
                else
                {
                    // we start directly with a new segment
                    //SEG_CNTR++;

                    // now print the segments
                        while( REMAIN_VEC_LEN >= SEG_LEN )
                        {
                            // set the color
                            if( SEG_CNTR % 2 == 0 )
                            {
                                glColor4f(1.0f,1.0f,1.0f,0.0f);
                                glLineWidth((GLfloat)(3.2*this->width) );
                            }
                            else
                            {
                                glColor4f(0.2f,0.2f,0.2f,0.0f);
                                glLineWidth((GLfloat)(3.2*this->width) );
                            }

                            // specify the vector offset
                            diff_x = SEG_LEN / VEC_LEN * ( Ptr->next->screen_x - Ptr->screen_x );
                            diff_y = SEG_LEN / VEC_LEN * ( Ptr->next->screen_y - Ptr->screen_y );

                            // draw the segment
                            glBegin(GL_LINES);
                                glVertex2f(start_x,start_y);
                                glVertex2f(start_x+diff_x,start_y+diff_y);
                            glEnd();
                            SEG_CNTR++;
                            // update the start location of the next segment
                            start_x = start_x + diff_x;
                            start_y = start_y + diff_y;

                            // update the remaining vector length
                            REMAIN_VEC_LEN = REMAIN_VEC_LEN - SEG_LEN;

                        }

                        // check if we have to open an incomplete segment
                        if( REMAIN_VEC_LEN > 0 )
                        {
                            // start a segment that is continued on the next arc
                            // set the color
                            if( SEG_CNTR % 2 == 0 )
                            {
                                glColor4f(1.0f,1.0f,1.0f,0.0f);
                                glLineWidth((GLfloat)(3.2*this->width) );
                            }
                            else
                            {
                                glColor4f(0.2f,0.2f,0.2f,0.0f);
                                glLineWidth((GLfloat)(3.2*this->width) );
                            }

                            // specify the vector offset
                            diff_x = REMAIN_VEC_LEN / VEC_LEN * ( Ptr->next->screen_x - Ptr->screen_x );
                            diff_y = REMAIN_VEC_LEN / VEC_LEN * ( Ptr->next->screen_y - Ptr->screen_y );

                            // draw the segment
                            glBegin(GL_LINES);
                                glVertex2f(start_x,start_y);
                                glVertex2f(start_x+diff_x,start_y+diff_y);
                            glEnd();
                        }

                        LEN_FROM_LAST = SEG_LEN - REMAIN_VEC_LEN;
                        REMAIN_VEC_LEN = 0;
                    }
                }


                glLineWidth((GLfloat)1.0);
                glDisable( GL_LINE_SMOOTH );
                Ptr = Ptr->next;
            }
        }
}
